-- cd.adb: using pointers to arrays and strings to represent audio CD info

with Ada.Text_IO;
use Ada;

procedure CD is

   type String_Pointer is access String;
   type Tracks_Type is array (Positive range <>) of String_Pointer;
   type Tracks_Pointer is access Tracks_Type;
   subtype Year_Range is Integer range 1900..2990;


   type Disc is record
      Artist, Album: String_Pointer;
      Year: Year_Range;
      Tracks: Tracks_Pointer;
   end record;

   function New_Disk (Artist,Album: String; Y: Year_Range; Tracks: Tracks_Type) return Disc is
   begin
      return Disc' (
         Artist=>new String' (Artist),
         Album=>new String' (Album),
         Year=>Y,
         Tracks=>new Tracks_Type' (Tracks)
      );
   end New_Disk;

   CD1, CD2: Disc;

begin

   CD1 := Disc'(
      Artist=>new String' ("Bob Dylan"),
      Album =>new String' ("Freewheelin'"),
      Year  =>1963,
      Tracks=>new Tracks_Type' (
         01=>new String' ("Blowin' in The Wind"),
         02=>new String' ("Girl From The North Country"),
         03=>new String' ("Masters of War"),
         04=>new String' ("Down The Highway"),
         05=>new String' ("Bob Dylan's Blues"),
         06=>new String' ("A Hard Rain's A-Gonna Fall"),
         07=>new String' ("Don't Think Twice, It's all Right"),
         08=>new String' ("Bob Dylan's Dream"),
         09=>new String' ("Oxford Town"),
         10=>new String' ("Talking World War III Blues"),
         11=>new String' ("Corrina, Corrina"),
         12=>new String' ("Honey, Just Allow Me One More Chance"),
         13=>new String' ("I Shall Be Free")
      )
   );

   CD2 := New_Disk ("Bob Dylan", "Highway 61 Revisited", 1965,
      Tracks=>Tracks_Type' (
         01=>new String' ("Like A Rolling Stone"),
         02=>new String' ("Tombstone Blues"),
         03=>new String' ("It Takes A Lot To Laugh, It Takes A Train To Cry"),
         04=>new String' ("From A Buick 6"),
         05=>new String' ("Ballad of A Thin Man"),
         06=>new String' ("Queen Jane Approximately"),
         07=>new String' ("Highway 61 Revisited"),
         08=>new String' ("Just Like Tom Thumb's Blues"),
         09=>new String' ("Desolation Row")
      )
   );

   if CD1.Artist=CD2.Artist then
      Text_IO.Put_Line ("Yes");
   else
      Text_IO.Put_Line ("No");
   end if;

end CD;
