
-- For Example IO see: http://www.cs.uni.edu/~mccormic/1510/solutions/Assign7.pdf
-- http://www.adaic.org/resources/add_content/standards/05rm/html/RM-A-10-1.html
-- http://www.adaic.org/resources/add_content/standards/05rm/html/RM-0-5.html

WITH Ada.Text_IO;
WITH Ada.Integer_Text_IO;
with Ada.Text_IO.Text_Streams;
use Ada;

procedure FindWord is

   type String_Pointer is access String;

   type WordFreq is record
      Word: String_Pointer;
      Freq: Integer;
   end record;

   function New_WordFreq (MyWord: String; MyFreq: Integer) return WordFreq is
   begin
      return WordFreq' (
         Word=>new String' (MyWord),
         Freq=>MyFreq
      );
   end New_WordFreq;

   WD1, WD2: WordFreq ;

begin

   WD1 := WordFreq'(
         Word=>new String' ("Hello"),
         Freq=>2
   );

   WD2 := New_WordFreq  ("Goodbye", 4);

   if WD1.Word=WD2.Word then
      Text_IO.Put_Line ("Yes");
   else
      Text_IO.Put_Line ("No");
   END IF;

   Integer_Text_IO.Put(Item => WD1.Freq, Width => 2);
   Integer_Text_IO.Put(Item => WD2.Freq, Width => 2);
   Text_IO.Put_Line (Item => WD1.Word, Width => 10);

end FindWord;
